io.stdout:setvbuf('no')

local Heros={}
Heros.size = 10
Heros.PosX = 390
Heros.PosY = 565
Heros.Pos = "Center"

local Ennemi={}
Ennemi.vy = 200
Ennemi.Posxa = 130
Ennemi.Posxb = 260
Ennemi.Posxc = 390

local SpawnEnnemiStatutNumber = 0

local CreateEnemyTimerMax = 0.6
local CreateEnemyTimer = CreateEnemyTimerMax

local enemies = {}

local life = 3

local Score = 0

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end


function SpawnEnnemi()
  
  SpawnEnnemiStatut = true
  SpawnEnnemiStatutNumber = math.random(3)
  
end

function love.load()
  
  largeur = love.graphics.getWidth()
  hauteur = love.graphics.getHeight()
  
  background_image = love.graphics.newImage("images/background.png")
  EnemiCar = love.graphics.newImage("images/EnemiCar.png")
  Soldier = love.graphics.newImage("images/Soldier.png")
  
end

function love.update(dt)
  
  if life > 0 then
    if SpawnEnnemiStatut == "true" then
      if SpawnEnnemiStatutNumber == 1 then
        Ennemi.PosX = 130
      end
      if SpawnEnnemiStatutNumber == 2 then
        Ennemi.PosX = 260
      end
      if SpawnEnnemiStatutNumber == 3 then
        Ennemi.PosX = 390
      end
      SpawnEnnemiStatut = false
    end
    
    if TouchePressed == "right" and Heros.Pos ~= "Right" then
      Heros.PosX = Heros.PosX + 130
      SpawnEnnemi()
      TouchePressed = empty

    end
    
    if TouchePressed == "left" and Heros.Pos ~= "Left" then
      Heros.PosX = Heros.PosX - 130
      SpawnEnnemi()
      TouchePressed = empty

    end
    
    if Heros.PosX >= 0 and Heros.PosX <= 261 then
      Heros.Pos = "Left"
    end
    
    if Heros.PosX >= 261 and Heros.PosX <= 391 then
      Heros.Pos = "Center"
    end
    
    if Heros.PosX >= 391 and Heros.PosX <= 521 then
      Heros.Pos = "Right"
    end
    
    CreateEnemyTimer = CreateEnemyTimer - (1 * dt)
    
    if CreateEnemyTimer < 0 then
      CreateEnemyTimer = CreateEnemyTimerMax
      
      EnnemiRandomGeneration = math.random(3)
      EnnemiPosX = 260
      
      
      if EnnemiRandomGeneration == 1 then
        EnnemiPosX = 260
      end
      
      if EnnemiRandomGeneration == 2 then
        EnnemiPosX = 390
      end
      
      if EnnemiRandomGeneration == 3 then
        EnnemiPosX = 520
      end
      
      newEnemy = { x = EnnemiPosX, y = -10}
      table.insert(enemies, newEnemy)
      
    end
    
    for i, enemy in ipairs(enemies) do
      enemy.y = enemy.y + (Ennemi.vy * dt)
      
      if enemy.y > 610 then
        Ennemi.vy = Ennemi.vy + 5
        table.remove(enemies, i)
        Score = Score + (1* Ennemi.vy)
      end
      
    end
    
    for i, enemy in ipairs(enemies) do
      --enemy hit player
      if CheckCollision(enemy.x, enemy.y, 10, 10, Heros.PosX, Heros.PosY, 10, 10) then
        table.remove(enemies, i)
        life = life - 1
      end
    end 
  end
  
end

function love.draw()
  
  love.graphics.setColor(255, 255, 255)
  love.graphics.draw(background_image, 200, 0)

  love.graphics.draw(Soldier, Heros.PosX, Heros.PosY)
  
  love.graphics.print("Score :"..Score.." Life :"..life, 0, 550)

  
    --enemies
  for i, enemy in ipairs(enemies) do
    love.graphics.setColor(255, 255, 255)
    love.graphics.draw(EnemiCar, enemy.x - 11, enemy.y)
  end
  
  if life == 0 then
    love.graphics.setColor(255, 255, 255)
    love.graphics.printf("PERDU", 300, 300, 200,"center")
  end
  
  
end

function love.keypressed(key)
  
  TouchePressed = key
  
end